﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace DeaneBarker.Kiwi
{
    [DebuggerDisplay("{Key}")]
    public class MetaItem
    {
        public string Owner { get; set; }
        public string Key { get; set; }
        public object Value { get; set; }

        public Scope Scope { get; set; }

        public MetaItem() { }

        public string Name => string.Concat(Owner, ".", Key);

        public MetaItem(string owner, string key, object value)
        {

            Scope = Scope.Normal;
            if(key.StartsWith("!"))
            {
                Scope = Scope.Elevated;
                key = key.TrimStart("!".ToCharArray());
            }

            Owner = owner;
            Key = key ?? throw new ArgumentNullException("Key cannot be null.");
            Value = value;
        }
    }

    public enum Scope
    {
        Normal,
        Elevated
    }
}
