﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace DeaneBarker.Kiwi
{
    public class SectionMap
    {
        public bool IsFirst { get; set; }
        public bool IsLast { get; set; }
        public int Total { get; set; }
        public int Index { get; set; }
        public int Ordinal { get; set; }
        public Section Prev { get; set; }
        public Section Next { get; set; }
        public int TotalOfType { get; set; }
        public int IndexOfType { get; set; }
        public int OrdinalOfType { get; set; }
        public bool IsFirstOfType { get; set; }
        public bool IsLastOfType { get; set; }
        public bool IsNextSameType { get; set; }
        public bool IsPrevSameType { get; set; }

        // I added the below just to make the logic easier to figure out 
        public bool FirstInSeries { get; set; }
        public bool LastInSeries { get; set; }

        public SectionMap(List<Section> sections, int thisSectionIndex)
        {
            var section = sections[thisSectionIndex];

            IsFirst = thisSectionIndex == 0;
            IsLast = thisSectionIndex == sections.Count - 1;
            Total = sections.Count;
            Index = thisSectionIndex;
            Ordinal = thisSectionIndex + 1;
            

            Prev = sections.ElementAtOrDefault(thisSectionIndex - 1);
            IsPrevSameType = Prev?.Name == section.Name;
            FirstInSeries = !IsPrevSameType;

            Next = sections.ElementAtOrDefault(thisSectionIndex + 1);
            IsNextSameType = Next?.Name == section.Name;
            LastInSeries = !IsNextSameType;

            var sectionsOfType = sections.Where(s => s.Name == section.Name).ToList();

            TotalOfType = sectionsOfType.Count;
            IndexOfType = sectionsOfType.FindIndex(s => s == section);
            OrdinalOfType = IndexOfType + 1;
            IsFirstOfType = IndexOfType == 0;
            IsLastOfType = IndexOfType == sectionsOfType.Count - 1;
        }
    }
}
