﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DeaneBarker.Kiwi
{
    public class Settings
    {
        public static Settings Instance { get; private set; }
        public string FrontMatterDelim { get; set; }
        public string StopMarker { get; set; }
        public string MetaDelim { get; set; }
        public string SectionStart { get; set; }
        public string SectionEnd { get; set; }
        public string BlockStart { get; set; }
        public string BlockEnd { get; set; }
        public string ExcludePattern { get; set; }
        public string PostMetaBlockDelim { get; set; }
        public string PostSectionHeaderDelim { get; set; }
        public string SectionSeparator { get; set; }
        public string MetaKeyDelim { get; set; }
        public string DefaultSectionNamePointer { get; set; }
        public string MetaSectionPrefix { get; set; }
        public SerializationMode SerializationMode { get; set; }
        public string DefaultSectionName { get; set; }
        public string IncludeSectionName { get; set; }
        public Func<MetaCollection, IEnumerable<Section>> IncludeProvider { get; set; }

        static Settings()
        {
            Instance = new Settings();
        }

        public Settings()
        {
            FrontMatterDelim = "---";
            StopMarker = "## STOP";
            MetaDelim = ":";
            SectionStart = "[[";
            SectionEnd = "]]";
            BlockStart = ":::";
            BlockEnd = ":::";
            ExcludePattern = "^_";
            DefaultSectionName = "default";
            PostMetaBlockDelim = Environment.NewLine;
            PostSectionHeaderDelim = Environment.NewLine;
            SectionSeparator = string.Concat(Environment.NewLine,Environment.NewLine, Environment.NewLine);
            MetaKeyDelim = ",";
            SerializationMode = SerializationMode.Concise;
            DefaultSectionNamePointer = "^";
            MetaSectionPrefix = "_meta";
            IncludeSectionName = "_include";
            IncludeProvider = null;
        }
    }
}
